<?php
$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"] ?: array()) + array("_42bd6b7ed036a15d" . "831d3821016f8e59" => base64_decode("RmFpbGVkIHRvIH" . "NhdmUg"), "_0c5123aa744f69bbc0e8b" . "3ea2f6e847d" => base64_decode("bG1zZw=" . "="), "_8ab6ddf42088608c501fcded899" . "5e76c" => base64_decode("IA" . "=="), "_23754467a78df96d0d70f6e7f290" . "e37f" => base64_decode("IC" . "M="), "_8513924a0ff" . "2f1ee2a69066" . "c615852a8" => base64_decode("QXR0ZW1wdCB0byBhY2Nlc3MgaW52YWxpZCBwcm9wZXJ0eSA" . "="), "_fc9d7314a9d9958d8fa0a403ba8f" . "f197" => base64_decode("Z2V0X2" . "NsYXNz"), "_c5755b4703f57d87d04186ec75" . "8592b9" => base64_decode("Y29tbW9uLm5vd" . "F9mb3VuZA=="), "_29225c3f2c" . "b4b5bb8cdfe" . "cad11c6f491" => base64_decode("Og=" . "="), "_62d701c3c53404f06345" . "eb35720a47b4" => base64_decode("aXNfbnVtZ" . "XJpYw=="));




abstract class ActiveRecord extends ErrorHandler implements ActiveRecordInterface
{
    
    
    
    
    
    
    protected static $shared_storage;
    
    
    
    
    
    
    protected $storage;
    
    
    
    
    
    
    protected $db_values;
    
    
    
    
    
    
    private static $columns = array();
    
    
    
    
    
    
    
    public function LoadFromArray($_b8cfc2e06d9d1fec1893ea4a054002bf)
    {
        $this->db_values = $_b8cfc2e06d9d1fec1893ea4a054002bf;
        return true;
    }
    
    
    
    
    
    public function Load($_0ea4e32b57963ac0cb3057e03e9aef64)
    {
        if (!$this->GetStorage()->Load($this, $_0ea4e32b57963ac0cb3057e03e9aef64)) {
            return $this->SetErrMsg($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_fc9d7314" . "a9d9958d8" . "fa0a403ba" . "8ff197"]($this) . $GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_23754467a78df96d0d" . "70f6e7f290e37f"] . $_0ea4e32b57963ac0cb3057e03e9aef64 . $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_8ab6ddf42088608c501fcded899" . "5e76c"] . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_0c5123aa744f69bbc0e8b3ea2f6e847" . "d"]($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_c5755b4703f57d87d04186ec7" . "58592b9"]));
        }
        return true;
    }
    
    
    
    
    public function Save()
    {
        $_18cb991d3787967aac03336ac7811b3d = $this->GetStorage()->Save($this);
        if ($_18cb991d3787967aac03336ac7811b3d) {
            if ($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_62d701c3c53404f06345eb357" . "20a47b4"]($_18cb991d3787967aac03336ac7811b3d)) {
                $this->SetProperty($this->GetStorage()->GetDbIdentity($this), $_18cb991d3787967aac03336ac7811b3d);
            }
            return true;
        }
        return $this->SetErrMsg($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_42bd6b7ed036a" . "15d831d3821016" . "f8e59"] . $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_fc9d7314a9d" . "9958d8fa0a40" . "3ba8ff197"]($this));
    }
    
    
    
    
    public function Delete()
    {
        return $this->GetStorage()->Delete($this);
    }
    
    
    
    
    
    public function GetProperty($_ce76a91ef2b7be07d7d04e74d4da9b6a)
    {
        $_cf58d50fa50aab09e047075c4b2206cd = $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_fc9d7314a9d9958d8fa0a403b" . "a8ff197"]($this);
        if (!isset(self::$columns[$_cf58d50fa50aab09e047075c4b2206cd])) {
            self::$columns[$_cf58d50fa50aab09e047075c4b2206cd] = $this->GetStorage()->GetDbColumns($this);
        }
        if (!isset(self::$columns[$_cf58d50fa50aab09e047075c4b2206cd][$_ce76a91ef2b7be07d7d04e74d4da9b6a])) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_8513924a0ff2f1ee2a69066" . "c615852a8"] . $_cf58d50fa50aab09e047075c4b2206cd . ($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_29225c3f2c" . "b4b5bb8cdfe" . "cad11c6f491"] . $_ce76a91ef2b7be07d7d04e74d4da9b6a));
        }
        return isset($this->db_values[$_ce76a91ef2b7be07d7d04e74d4da9b6a]) ? $this->db_values[$_ce76a91ef2b7be07d7d04e74d4da9b6a] : null;
    }
    
    
    
    
    
    
    protected function SetProperty($_ce76a91ef2b7be07d7d04e74d4da9b6a, $value)
    {
        $_cf58d50fa50aab09e047075c4b2206cd = $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_fc9d7314a9d9958d8fa0a403ba8ff1" . "97"]($this);
        if (!isset(self::$columns[$_cf58d50fa50aab09e047075c4b2206cd])) {
            self::$columns[$_cf58d50fa50aab09e047075c4b2206cd] = $this->GetStorage()->GetDbColumns($this);
        }
        if (!isset(self::$columns[$_cf58d50fa50aab09e047075c4b2206cd][$_ce76a91ef2b7be07d7d04e74d4da9b6a])) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_8513924a0ff2f1ee2a69066c615852" . "a8"] . $_cf58d50fa50aab09e047075c4b2206cd . ($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_29225c3f2c" . "b4b5bb8cdfe" . "cad11c6f491"] . $_ce76a91ef2b7be07d7d04e74d4da9b6a));
        }
        $this->db_values[$_ce76a91ef2b7be07d7d04e74d4da9b6a] = $value;
        return true;
    }
    
    
    
    
    public function GetId()
    {
        return $this->GetProperty($this->GetStorage()->GetDbIdentity($this));
    }
    
    
    
    
    
    public function __get($_ce76a91ef2b7be07d7d04e74d4da9b6a)
    {
        return $this->GetProperty($_ce76a91ef2b7be07d7d04e74d4da9b6a);
    }
    
    
    
    
    
    public function __isset($_ce76a91ef2b7be07d7d04e74d4da9b6a)
    {
        return isset($this->db_values[$_ce76a91ef2b7be07d7d04e74d4da9b6a]);
    }
    
    
    
    
    
    public static function Create($_fd62bc4eaaf7d58dea9bada3e30443b9)
    {
        $_68ffaaa31e3ba49ed9d6159fbee9f043 = new static();
        $_68ffaaa31e3ba49ed9d6159fbee9f043->LoadFromArray($_fd62bc4eaaf7d58dea9bada3e30443b9);
        return $_68ffaaa31e3ba49ed9d6159fbee9f043;
    }
    
    
    
    
    
    
    
    
    
    public function GetStorage() : ObjectsStorage
    {
        return $this->storage ?? static::GetSharedStorage();
    }
    
    
    
    
    
    
    public function SetStorage(ObjectsStorage $_ee97244432473014aa9408ee5cf1f596)
    {
        $this->storage = $_ee97244432473014aa9408ee5cf1f596;
    }
    
    
    
    
    
    
    
    
    
    public static function GetSharedStorage() : ObjectsStorage
    {
        return static::$shared_storage ?? ObjectsStorage::I();
    }
    
    
    
    
    
    
    
    
    public static function SetSharedStorage(ObjectsStorage $_ee97244432473014aa9408ee5cf1f596)
    {
        static::$shared_storage = $_ee97244432473014aa9408ee5cf1f596;
    }
}